//  ** Revision History **
//  14-Mar-1993 (AH) Release 1.0.0.000
//  12-Nov-1992 (AH) Change Event added
//  12-Nov-1992 (Change event added. Trigged upon picturechange.) AH
//  12-Nov-1992 (Timing property has changed name to Interval.) Two new enum values for Style ANIMATECLICKFORWARD/ANIMATECLICKBACKWARD
//  03-Jul-1992 (AH) About Box added
//  24-Jun-1992 (AH) END Event added
//  24-Jun-1992 (AH) Click Event added so it trigger also in Play-mode when picture changes.
//  22-Jun-1992 (AH) Flyttat till PWB
//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:        Picture.c   MULTIPUSH      
//   
// PURPOSE:     Animation (part of EuroTool project)
//   
// COMMENTS:     
//   
// HISTORY:     920606AH
//   
//****************************************************************************                    


#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include "esmpush.h"


#include "version.h"
#define  CTL_DATA
#include "picture.h"
#include "vb1.h"		// Support for Visual Basic 1.0
#include "vb2.h"		// Support for Visual BAsic 2.0
#include "helpid.h"
               
//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog; 
HANDLE  ghWndPic;              // handle for hWnd of Control

//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR PaintPic(PANIMATE panimate, HWND hWnd, HCTL hctl, HDC hdc);

//---------------------------------------------------------------------------
// Pix Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export AnimateCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG   lp)
{
    PANIMATE panimate = NULL;

    switch (msg)
    {            
    case WM_CREATE:
        panimate = (PANIMATE)VBDerefControl(hctl);
        panimate->Interval = 1000;
        panimate->AutoRepeat = FALSE;
        panimate->fromPicture = 0;
        panimate->toPicture = 1;
        panimate->Play=FALSE;
        panimate->Style=ANIMATECLICK;
        panimate->Value = 0;
        panimate->AutoSize=FALSE;
        panimate->Value=panimate->fromPicture; 
        panimate->fgo = FALSE;
        panimate->RopCode = SRCCOPY;
        panimate->DrawMode = 10;

#ifndef RUNTIMEVERSION                                
        // set the property text for the About dialog
        SetAboutText(hctl, IPROP_ANIMATE_ABOUT); 
#endif            
                  
        VBSetControlProperty(hctl, IPROP_ANIMATE_BACKCOLOR, PIC_BACKGROUND_DEFAULT);
        if (VBGetMode() == MODE_RUN) {                          
            panimate = (PANIMATE)VBDerefControl(hctl);
            if (!SetTimer(hWnd,1, panimate->Interval, NULL))
                return(ERR_Timer); // No timer available        
        }                          
        break;
      
#ifndef RUNTIMEVERSION    
	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_ANIMATE_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_ANIMATE_AUTOREPEAT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_autorepeat);
			    		return 0L;                                                        
                
                	case IPROP_ANIMATE_AUTOSIZE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_autosize);
			    		return 0L; 
            	
                	case IPROP_ANIMATE_HWND:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_hwnd);
			    		return 0L;                                            
            
            		case IPROP_ANIMATE_INTERVAL:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_interval);
			    		return 0L;                                            
            
            		case IPROP_ANIMATE_PICTURE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picture);
			    		return 0L;                                            
            
            		case IPROP_ANIMATE_PLAY:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_play);
			    		return 0L;                                            
            
            		case IPROP_ANIMATE_FROMPICTURE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_playfrom);
			    		return 0L;                                            
            
            		case IPROP_ANIMATE_TOPICTURE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_playto);
			    		return 0L;                                       
            
            		case IPROP_ANIMATE_PICSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_style);
			    		return 0L;                                      
            
            		case IPROP_ANIMATE_VALUE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_value);
			    		return 0L;                                           
            
				}
              	break;
                
        case VBHELP_EVT:
            // High byte is unused.
		    // Keyword is: "<classname>"                          
            if (HIBYTE(wp) == IEVENT_ANIMATE_END) 
		    	WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, event_end); 
            return OK;
        
		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, multipush);
		    return 0L;
	}
	break;                            
      
    case VBM_INITPROPPOPUP:
        switch (wp) {
	    case IPROP_ANIMATE_ABOUT:
                hctlDialog  = hctl;
                ipropDialog = wp;
                return (LONG)HwndInitAboutPopup();
        }
        break; 
#endif
            
    case WM_PAINT:
        panimate = (PANIMATE)VBDerefControl(hctl);
        if (wp)
            PaintPic(panimate, hWnd, hctl, (HDC)wp);
        else
        {
            PAINTSTRUCT ps;

            BeginPaint(hWnd, &ps);
            PaintPic(panimate, hWnd, hctl, ps.hdc);
            EndPaint(hWnd, &ps);
        }
        break;

    case WM_ERASEBKGND:
        return OK;
        
    case WM_TIMER: 
        panimate=VBDerefControl(hctl);
        if (VBGetMode() == MODE_RUN && panimate->Style != ANIMATECLICK
                                    && panimate->Style != ANIMATECLICKBACK 
                                    && panimate->Play) {
            panimate = (PANIMATE)VBDerefControl(hctl); 
             
            // here we handle AutoPlay forward and AutoPlay forward
            // after Click  
            if ((panimate->Style == ANIMATEFORWARD) || 
                (panimate->fgo && panimate->Style == ANIMATECLICKFORWARD)) {
                panimate->Value++;
                if (panimate->Value > panimate->toPicture) {
                    if (panimate->AutoRepeat) {
                        panimate->Value = panimate->fromPicture;    
                    }
                    else {
                        panimate->Value = panimate->toPicture;
                        panimate->Play = FALSE;  
                    	panimate->fgo = FALSE;
                    }                                           
                    VBFireEvent(hctl, IEVENT_ANIMATE_END, NULL);
                }  
            	InvalidateRect(hWnd, NULL, TRUE);  
            }       
        
            // here we handle AutoPlay backward and AutoPlay backward 
            // after Click
            if (panimate->Style == ANIMATEBACKWARD || 
                (panimate->fgo && panimate->Style == ANIMATECLICKBACKWARD)) {
                panimate->Value--;
                if (panimate->Value < panimate->fromPicture || panimate->Value < 0) {
                    if (panimate->AutoRepeat) {
                        panimate->Value = panimate->toPicture;
                    }
                    else {
                        panimate->Value = panimate->fromPicture;
                        panimate->Play = FALSE;
                    }                     
                	panimate->fgo = FALSE;
                    VBFireEvent(hctl, IEVENT_ANIMATE_END, NULL);
                }  
                InvalidateRect(hWnd, NULL, TRUE);
            }   
            // Fire Change Event
        	VBFireEvent(hctl, IEVENT_ANIMATE_CHANGE, NULL);                               
        } 
        break;

    case WM_RBUTTONDBLCLK: 
            if (VBGetMode() == MODE_DESIGN) {
            	WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, multipush);
            	return OK;
            }
            break;
            
    case WM_LBUTTONDBLCLK:
    case WM_LBUTTONDOWN: 
        panimate=(PANIMATE)VBDerefControl(hctl);
    
        // Handle click forward
        if (panimate->Style == ANIMATECLICK) {
            panimate->Value++; 
            // Fire Change Event
        	VBFireEvent(hctl, IEVENT_ANIMATE_CHANGE, NULL);
            if (panimate->Value > panimate->toPicture)
                panimate->Value = panimate->fromPicture;
            InvalidateRect(hWnd, NULL, TRUE);    
        }                     
    
        // Handle click backward
        if (panimate->Style == ANIMATECLICKBACK) {
            panimate->Value--;
            // Fire Change Event
        	VBFireEvent(hctl, IEVENT_ANIMATE_CHANGE, NULL);
            if (panimate->Value < panimate->fromPicture)
                panimate->Value = panimate->toPicture;
            InvalidateRect(hWnd, NULL, TRUE);            
        }
    
        // Handle click forward autoplay    
        if (panimate->Style == ANIMATECLICKFORWARD) {
            panimate->Value++;
            // Fire Change Event
        	VBFireEvent(hctl, IEVENT_ANIMATE_CHANGE, NULL);
            if (panimate->Value > panimate->toPicture)
                panimate->Value = panimate->fromPicture;
            panimate->fgo = TRUE;  
            panimate->Play = TRUE;
            InvalidateRect(hWnd, NULL, TRUE);
        }
    
        // Handle click backward autoplay
        if (panimate->Style == ANIMATECLICKBACKWARD) { 
            panimate->Value--;
            // Fire Change Event
        	VBFireEvent(hctl, IEVENT_ANIMATE_CHANGE, NULL);
            if (panimate->Value < panimate->fromPicture)
                panimate->Value = panimate->toPicture; 
            panimate->fgo = TRUE;
            panimate->Play = TRUE;
            InvalidateRect(hWnd, NULL, TRUE);  
        }
        break;  
    
       
    case VBM_GETPROPERTY:              
        switch (wp)
        {
        case IPROP_ANIMATE_PICTURE:    // Get element of List prop array
            {
            LONG          i;
            LPDATASTRUCT  lpDs = (LPDATASTRUCT)lp;

            i = lpDs->index[0].data;
            if (i < 0 || i >= PICMAX)
            return ERR_BadIndex;

            panimate = (PANIMATE)VBDerefControl(hctl);
            lpDs->data = panimate->hpicAnimate[i];
            return ERR_None;
            }
        }
        break;
    
    case VBM_SETPROPERTY:
        switch (wp)
        {
        case IPROP_ANIMATE_PICTURE:    // Set element of List prop array
            {
            LONG          i;
            LPDATASTRUCT  lpDs =(LPDATASTRUCT)lp;

            i = lpDs->index[0].data;
            if (i < 0 || i >= PICMAX)
            return ERR_BadIndex;

            panimate = (PANIMATE)VBDerefControl(hctl);
            panimate->hpicAnimate[i] = (HPIC)lpDs->data;
            return ERR_None;
            } 
        case IPROP_ANIMATE_INTERVAL:
            panimate = (PANIMATE)VBDerefControl(hctl);
            SetTimer(hWnd, 1, panimate->Interval, NULL);    
            return ERR_None;
        
        case IPROP_ANIMATE_FROMPICTURE:
            panimate = (PANIMATE)VBDerefControl(hctl);
            if (panimate->Value < panimate->fromPicture) 
                panimate->Value = panimate->fromPicture;
            InvalidateRect(hWnd, NULL, TRUE);  
       	    break;
        
        case IPROP_ANIMATE_PLAY:
            panimate = (PANIMATE)VBDerefControl(hctl);
            if (panimate->Play && (panimate->Style == ANIMATEFORWARD))
                panimate->Value = panimate->fromPicture;             
            if (panimate->Play && (panimate->Style == ANIMATEBACKWARD))
                panimate->Value = panimate->toPicture;
            break;
        
        case IPROP_ANIMATE_AUTOSIZE:
            InvalidateRect(hWnd, NULL, TRUE);
            break;           
        
        case IPROP_ANIMATE_VALUE:
            InvalidateRect(hWnd, NULL, TRUE);
            // Fire Change Event
        	VBFireEvent(hctl, IEVENT_ANIMATE_CHANGE, NULL);
        	break;
        
        case IPROP_ANIMATE_DRAWMODE:
            InvalidateRect(hWnd, NULL, TRUE);
            panimate = (PANIMATE)VBDerefControl(hctl);
        	switch(panimate->DrawMode) 
        	{
             	case 0:                          
                    panimate->RopCode = BLACKNESS;
                    break;
                case 1:                          
                    panimate->RopCode = DSTINVERT;
                    break;
                case 2:                           
                    panimate->RopCode = MERGECOPY;
                    break;
                case 3:                           
                    panimate->RopCode = MERGEPAINT;
                    break;
                case 4:                             
                    panimate->RopCode = NOTSRCCOPY;
            		break;
            	case 5:                         
                    panimate->RopCode = NOTSRCERASE;
                    break;
                case 6:                           
                    panimate->RopCode = PATCOPY;
            		break;
            	case 7:                          
                    panimate->RopCode = PATINVERT;
                    break;
                case 8:                        
                    panimate->RopCode = PATPAINT;
                    break;
                case 9:                         
                    panimate->RopCode = SRCAND;
                    break;
                case 10:                         
                    panimate->RopCode = SRCCOPY;
                    break;
                case 11:                          
                    panimate->RopCode = SRCERASE;
                    break;
                case 12:                         
                    panimate->RopCode = SRCINVERT;
                    break;
                case 13:                          
                    panimate->RopCode = SRCPAINT;
                    break;
                case 14:   
                    panimate->RopCode = WHITENESS;
                    break;   
        	}
        }
        break;

    case VBM_CHECKPROPERTY:
        switch (wp) {
            case IPROP_ANIMATE_PICTURE: {
                PIC     pic;

                VBGetPic((HPIC)lp, &pic);
                switch (pic.picType) {
                    case PICTYPE_BITMAP:
                    case PICTYPE_NONE:
                        InvalidateRect(hWnd, NULL, TRUE);
                        return ERR_None;
                }
                return VBSetErrorMessage(ERR_BadPixFmt,ERR_BadPixFmtStr);
            }
            
            case IPROP_ANIMATE_VALUE:
                panimate = (PANIMATE)VBDerefControl(hctl);
                if ((SHORT)lp > panimate->toPicture || (SHORT)lp <0)
                    return ERR_InvPropVal;
                return ERR_None;
                
            case IPROP_ANIMATE_TOPICTURE:
                panimate = (PANIMATE)VBDerefControl(hctl);
                if ((SHORT)lp <0 || (SHORT)lp > PICMAX)
                    return ERR_InvPropVal;
                return ERR_None;
                
            case IPROP_ANIMATE_FROMPICTURE:
                panimate = (PANIMATE)VBDerefControl(hctl);
                if ((SHORT)lp <0)
                    return ERR_InvPropVal;
                return ERR_None;
        }
        break;

    case WM_DESTROY:
        panimate = (PANIMATE)VBDerefControl(hctl);
        VBFreePic(panimate->hpicPict);
        if (VBGetMode() == MODE_RUN) {
            KillTimer(hWnd,1);            
        }    
        break;
    }

    return VBDefControlProc(hctl, hWnd, msg, wp, lp);
}



//---------------------------------------------------------------------------
// Paint the bitmap into the Pix control.
//---------------------------------------------------------------------------
VOID NEAR PaintPic(PANIMATE panimate, HWND hWnd, HCTL hctl,  HDC  hdc)
{
    PIC    pic;
    HPIC   hpic = panimate->hpicAnimate[panimate->Value];
    BITMAP bmp;
    HDC    hdcMem;
    RECT   rect;
    HBRUSH hbrush, hbrushOld;

    if (VBGetMode() == MODE_RUN) {
        VBGetPic(hpic, &pic);
        switch (pic.picType) {
        case PICTYPE_BITMAP:
            hbrush = CreateSolidBrush(GREY);
            hbrushOld = SelectObject(hdc, hbrush);
            GetObject(pic.picData.bmp.hbitmap, sizeof(BITMAP), (LPSTR)&bmp);
            hdcMem = CreateCompatibleDC(hdc);
            SelectObject(hdcMem, pic.picData.bmp.hbitmap);
            GetClientRect(hWnd, &rect);
            if (!panimate->AutoSize) {
                StretchBlt(hdc, 0, 0,
                    rect.right, rect.bottom, hdcMem, 0, 0,
                    bmp.bmWidth, bmp.bmHeight, panimate->RopCode);
            }
            else {          
                //LPRECT lprect; 
            
            	//GetClientRect(hWnd, lprect);
                //FillRect(hdc, lprect, hbrush);
                BitBlt(hdc,0,0,rect.right, rect.bottom, hdcMem, 0, 0, panimate->RopCode);    
            }
            DeleteDC(hdcMem);  //BitBlt
            SelectObject(hdc, hbrushOld);
            DeleteObject(hbrush);
            break;

        case PICTYPE_NONE: {
            HBRUSH  hbr;

            hbr = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR,
                        hdc, MAKELONG(hWnd, 0));
            GetClipBox(hdc, &rect);
            FillRect(hdc, &rect, hbr);
            break;
            }
        }
    }
    else {
        HSZ     ctlname;
        RECT    rect;
        HBRUSH  hbr;
        
        GetClientRect(hWnd, &rect);
        hbr = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR,
                                    hdc, MAKELONG(hWnd, 0));
        FillRect(hdc, &rect, hbr);
        VBGetControlProperty(hctl, IPROP_ANIMATE_CTLNAME, &ctlname);
        DrawText(hdc,VBDerefHsz(ctlname),-1,&rect,DT_CENTER | DT_VCENTER | DT_SINGLELINE);
        VBDestroyHsz(ctlname);
    }        
}
