//  ** Revision History **
//  22-Aug-1992 (AH - EuroSource AB) Added bytealign of window to speed up things

//****************************************************************************                   
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         Picture.h
//   
// PURPOSE:      Header file for Animate Control
//   
// COMMENTS:     
//   
// HISTORY:      920606A
//   
//****************************************************************************                    


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Animate control data and structs
//---------------------------------------------------------------------------
#define PICMAX                  20
#define PIC_BACKGROUND_DEFAULT  GREY                   

typedef struct tagANIMATE
{   
    HSZ		hszabout;
    HPIC    hpicPict;
    HPIC    hpicAnimate[PICMAX]; // Animation Picture Array
    BYTE	PicStyle[PICMAX];	// reserved - next picture style
    SHORT   Interval;       // Time in ms between pictures
    BOOL    AutoRepeat;     // TRUE if no ENDPLAY
    SHORT   fromPicture;    // Picture to start play from
    SHORT   toPicture;      // Picture to stop play at
    BOOL    Play;           // Animation on
    ENUM    Style;          // 0 Click, 1 Forward, 2 Backward
    ENUM    DrawMode;		// Style in wich picture is drawn
    DWORD   RopCode;		// Rop for drawing
    SHORT   Value;          // Picture number on Screen
    BOOL    AutoSize;       // use default size for picture
	BOOL	fgo;			// TRUE for continues
} ANIMATE;

typedef ANIMATE FAR * PANIMATE;


//---------------------------------------------------------------------------
// Control Procudure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export AnimateCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


//---------------------------------------------------------------------------
// Property info
//---------------------------------------------------------------------------
#ifdef CTL_DATA

PROPINFO Property_Animate_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(ANIMATE, hszabout)
};                     


PROPINFO propinfoPicPicture =
{
    "Picture",
    DT_PICTURE | PF_fSetMsg | PF_fGetMsg | PF_fNoShow | PF_fPropArray,
    OFFSETIN(ANIMATE,hpicAnimate)
};

PROPINFO propinfoPicTiming =
{
    "Timing",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fNoShow,
    OFFSETIN(ANIMATE,Interval)
};

PROPINFO propinfoPicAutoRepeat =
{
    "AutoRepeat",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,AutoRepeat)
};

PROPINFO propinfoPicfromPicture =
{
    "PlayFrom",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,fromPicture), 0
};

PROPINFO propinfoPictoPicture =
{
    "PlayTo",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,toPicture), 0
};

PROPINFO propinfoPicPlay =
{
    "Play",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,Play), 0
};

// Picture Styles       
#define ANIMATECLICK        0
#define ANIMATECLICKBACK    1
#define ANIMATEFORWARD      2
#define ANIMATEBACKWARD     3 
#define ANIMATECLICKFORWARD 4
#define ANIMATECLICKBACKWARD 5

PROPINFO propinfoPicStyle =
{
    "Style",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,Style), 0,
    0,
    "0 - Display picture by picture Forward when clicked.\0"
    "1 - Display picture by picture Backward when clicked.\0"
    "2 - AutoPlay Forward.\0"
    "3 - AutoPlay Backward.\0"
    "4 - AutoPlay forward when clicked.\0"
    "5 - AutoPlay backward when clicked.\0",
    ANIMATECLICKBACKWARD
};

PROPINFO propinfoPicValue =
{
    "Value",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,Value), 0
};


PROPINFO propinfoPicAutoSize =
{
    "AutoSize",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,AutoSize), 0
};
   
PROPINFO propinfoPicInterval =
{
    "Interval",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,Interval)
};                                  

PROPINFO propinfoPichWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
}; 

PROPINFO propinfoPicDrawMode =
{
    "DrawMode",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData,
    OFFSETIN(ANIMATE,DrawMode), 0,
    12,
    "1 - Black Pen.\0"
    "2 - NotMergePen.\0"
    "3 - MaskNotPen.\0"
    "4 - NotCopyPen\0"
    "5 - MaskPenNot.\0"
    "6 - Invert.\0"
    "7 - XorPen.\0"
    "8 - NotMaskPen.\0"
    "9 - MaskPen.\0"
    "10 - NotXorPen.\0"
    "11 - Nop.\0"
    "12 - MergeNotPen.\0"
    "13 - CopyPen (Default).\0"
    "14 - MergePenNot.\0"
    "15 - MergePen.\0"
    "16 - White Pen.\0",
    15
};                                                                
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_ANIMATE_CTLNAME     0
#define IPROP_ANIMATE_INDEX       1
#define IPROP_ANIMATE_BACKCOLOR   2
#define IPROP_ANIMATE_LEFT        3
#define IPROP_ANIMATE_TOP         4
#define IPROP_ANIMATE_WIDTH       5
#define IPROP_ANIMATE_HEIGHT      6
#define IPROP_ANIMATE_VISIBLE     7
#define IPROP_ANIMATe_PARENT      8
#define IPROP_ANIMATE_DRAGMODE    9
#define IPROP_ANIMATE_DRAGICON    10
#define IPROP_ANIMATE_TAG         11
#define IPROP_ANIMATE_PICTURE     12
#define IPROP_ANIMATE_TIMING      13
#define IPROP_ANIMATE_AUTOREPEAT  14
#define IPROP_ANIMATE_FROMPICTURE 15
#define IPROP_ANIMATE_TOPICTURE   16
#define IPROP_ANIMATE_PLAY        17
#define IPROP_ANIMATE_PICSTYLE    18
#define IPROP_ANIMATE_VALUE       19  
#define IPROP_ANIMATE_AUTOSIZE    20
#define IPROP_ANIMATE_BORDERSTYLE 21
#define IPROP_ANIMATE_ABOUT		  22
#define IPROP_ANIMATE_INTERVAL    23
#define IPROP_ANIMATE_HWND		  24 
#define IPROP_ANIMATE_DRAWMODE    25

#ifdef CTL_DATA
PPROPINFO Pic_Properties[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TAG,
    &propinfoPicPicture,
    &propinfoPicTiming,
    &propinfoPicAutoRepeat,
    &propinfoPicfromPicture,
    &propinfoPictoPicture,
    &propinfoPicPlay,
    &propinfoPicStyle,
    &propinfoPicValue,
    &propinfoPicAutoSize,
    PPROPINFO_STD_BORDERSTYLEOFF,   
    &Property_Animate_About,
    &propinfoPicInterval,
    &propinfoPichWnd,               
    &propinfoPicDrawMode,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
EVENTINFO Event_End =
{
    "End",
    0,
    0,
    NULL,
    ""
};   

EVENTINFO Event_Change =
{
    "Change",
    0,
    0,
    NULL,
    ""
};
           
#define IEVENT_ANIMATE_CHANGE				0                               
#define IEVENT_ANIMATE_CLICK               1
#define IEVENT_ANIMATE_DRAGDROP            2
#define IEVENT_ANIMATE_DRAGOVER            3 
#define IEVENT_ANIMATE_END		   			4

#ifdef CTL_DATA
PEVENTINFO Pic_Events[] =
{          
    &Event_Change,
    PEVENTINFO_STD_CLICK,
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,                
    &Event_End,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelAnimate =
{
    VB_VERSION,                         // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk | MODEL_fChildrenOk, // MODEL flags
    (PCTLPROC)AnimateCtlProc,           // Control procedures
    CS_VREDRAW | CS_HREDRAW |           // Class style
    CS_BYTEALIGNWINDOW,
    0,                                  // Default Windows style
    sizeof(ANIMATE),                    // Size of PIX structure
    IDBMP_PIC,                          // Palette bitmap ID
    "MultiPush",                        // Default control name
    "MultiPush",                        // Visual Basic class name
    NULL,                               // Parent class name
    Pic_Properties,                     // Property information table
    Pic_Events,                         // Event information table 
	IPROP_ANIMATE_PICTURE,				// Default property
	IEVENT_ANIMATE_END,					// Default event
	IPROP_ANIMATE_VALUE					// standard property
};
#endif  // CTL_DATA

LPMODEL modellistAnimate[] =
    {
    &modelAnimate,
    NULL
    };

MODELINFO modelinfoAnimate =
    {
    VB_VERSION, 			// VB version being used
    modellistAnimate		// MODEL list
    };

#endif  // RC_INVOKED

//---------------------------------------------------------------------------
